'**************************************************************************
'   Windows
' service_manager.vbs
'**************************************************************************
Option Explicit

'    
dim WSO, FSO, WshShell, objWMIService

set WSO = CreateObject("Scripting.WindowSystemObject")
set FSO = CreateObject("Scripting.FileSystemObject")
set WshShell = CreateObject("WScript.Shell")
set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2")


dim list_view_obj, data_array(), t, f, def_columns
dim Button_Update, Button_Stop, Button_Run, Button_Pause
dim Button_Continue, Button_Auto, Button_Manual, Button_Disable
dim Name_class, DisplayName_class, State_class, PathName_class, StartMode_class 

Const wbemFlagForwardOnly =32
Const wbemFlagReturnImmediately =16

'    
dim temp_file
temp_file = WshShell.ExpandEnvironmentStrings("%TEMP%") & "\" & FSO.GetTempName()


'*************************************************
'             
'*************************************************
Class new_class
	Dim  Name, DisplayName, State, PathName, StartMode
End Class
	
Class N_class
	Property Get name
		name = ""
	End Property
	Property Get width
		width = 100
	End Property
	Property Get type_f
		type_f = 1
	End Property
	 
	function set_data(item, data) 
		item.Text = data.Name   
	end function
End Class

Class DN_class
    Property Get name
		name = ""
	End Property
	Property Get width
		width = 100
	End Property
	Property Get type_f
		type_f = 1
	End Property
	 
	function set_data(item, data) 
		item.SubItems(0) = data.DisplayName
	end function
End Class

Class S_class
	Property Get name
		name = ""
	End Property
	Property Get width
		width = 80
	End Property
	Property Get type_f
		type_f = 1
	End Property
	 
	function set_data(item, data) 
		item.SubItems(1) = data.State
	end function
End Class

Class PT_class
	Property Get name
		name = ""
	End Property
	Property Get width
		width = 130
	End Property
	Property Get type_f
		type_f = 1
	End Property
	 
	function set_data(item, data) 
		item.SubItems(2) = data.PathName
	end function
End Class

Class SM_class
	Property Get name
		name = ""
	End Property
	Property Get width
		width = 100
	End Property
	Property Get type_f
		type_f = 1
	End Property
	 
	function set_data(item, data) 
		item.SubItems(3) = data.StartMode
	end function
End Class
'***************************************************


' *************************   ************************************************
set f = WSO.CreateForm(0, 0, 0, 0, WSO.Translate("WS_CONTROLBOX | WS_MINIMIZEBOX"))

f.Text = "  Windows"
f.ClientWidth = 700
f.ClientHeight = 600
f.CenterControl()
'***********************************************************************************************


'******************************************************************************
'                       
'*****************************************************************************
dim b, c
set b = f.Bevel(510, 90, 150,170, WSO.Translate("BS_LOWERED"))
b.Color = &HFFFFE0
set c = f.Bevel(510, 300, 150,130, WSO.Translate("BS_LOWERED"))
c.Color = &HFFFFE
'*******************************************************************************

'********************************************************************************
'                   
'********************************************************************************

'   
set Button_Update = f.CreateButton(530,10,100,25," ")
Button_Update.OnClick = getref("ServiceUpdate")

set t = f.CreateHyperLink(530,40,250,25,"www.scriptcoding.ru")

'     
set Button_Stop = f.CreateButton(530,100,100,25,"")
Button_Stop.OnClick = getref("ServiceStop")

'     
set Button_Run= f.CreateButton(530,130,100,25,"")
Button_Run.OnClick = getref("ServiceRun")

'     
set Button_Pause = f.CreateButton(530,160,100,25,"")
Button_Pause.OnClick = getref("ServicePause")

'     
set Button_Continue = f.CreateButton(530,190,100,25,"")
Button_Continue.OnClick = getref("ServiceContinue")

'********************************************************************************
'********************************************************************************

'     
set Button_Auto = f.CreateButton(520,310,135,25," ")
Button_Auto.OnClick = getref("ServiceAuto")

'    
set Button_Manual = f.CreateButton(520,340,130,25," ")
Button_Manual.OnClick = getref("ServiceManual")

' 
set Button_Disable = f.CreateButton(520,370,130,25,"")
Button_Disable.OnClick = getref("ServiceDisable")

'********************************************************************************

'********************************************************************************

'      
function fill_data_array()
dim colItems, objItem, inc, my_class, len_col
	Redim data_array(0)
    inc = 0
	'   
	set colItems = objWMIService.ExecQuery("Select * From Win32_Service")
	len_col = colItems.count
	Redim data_array(len_col)
		
	'   
	For Each objItem in colItems
	set my_class = new new_class
		with my_class
			.Name = objItem.Name
			.DisplayName = objItem.DisplayName
			.State = objItem.State
			.PathName = objItem.PathName
			.StartMode = objItem.StartMode
		end with
		
		set data_array(inc) = my_class
		inc = inc +1
	Next
	
end function
'***************************************************************

'***************************************************************
'   
'***************************************************************
 
set Name_class = new N_class
set DisplayName_class = new DN_class
set State_class = new S_class 
set PathName_class = new PT_class
set StartMode_class = new SM_class

def_columns = Array(Name_class, DisplayName_class, State_class, PathName_class, StartMode_class)
'***************************************************************

'    
function CreateListView()
dim def_col, column, ix

	'  ListView
	set list_view_obj = f.CreateListView( 0, 0, 500, 600,WSO.Translate("LVS_REPORT | LVS_OWNERDATA | LVS_SHOWSELALWAYS"))
    '  ListView
	list_view_obj.GridLines = true
	list_view_obj.RowSelect = true
	list_view_obj.ReadOnly = false
	list_view_obj.ItemIndex = 1
	
	'***************************************************************
	'             
	'***************************************************************
   
	for ix = 0 to UBound(def_columns)
		set column = list_view_obj.Columns.Add(def_columns(ix).name, def_columns(ix).width)
		column.DataType = def_columns(ix).type_f
	next
	
	'********************************************************
	'                 
	'********************************************************
	list_view_obj.OnData = getref("on_data")
	
	'     
	fill_data_array()
	'  
	list_view_obj.Count = UBound(data_array)
end function

'   
function ServiceUpdate()
	'   
	list_view_obj.Clear()
	
	fill_data_array()
	list_view_obj.Count = UBound(data_array)
end function

'-------------------------------------------------------------------------------
'                
'-------------------------------------------------------------------------------

'      
function ServiceStop(Sender)
	dim cur_service_name, ReturnCode, objStopService
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		set objStopService = objWMIService.Get("Win32_Service.Name=" & Chr(39) & cur_service_name & Chr(39))
		ReturnCode = objStopService.StopService()
		if ReturnCode = 0 then
			ServiceUpdate()
		end if
		WScript.Echo " : " & ReturnCode
	end if
end function

'      
function ServiceRun(Sender)
	dim cur_service_name, ReturnCode, objRunService
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		set objRunService = objWMIService.Get("Win32_Service.Name=" & Chr(39) & cur_service_name & Chr(39))
		ReturnCode = objRunService.StartService()
		if ReturnCode = 0 then
			ServiceUpdate()
		end if
		WScript.Echo " : " & ReturnCode
	end if
end function

'      
function ServicePause(Sender)
	dim cur_service_name, ReturnCode, objPauseService
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		
		set objPauseService = objWMIService.Get("Win32_Service.Name=" & Chr(39) & cur_service_name & Chr(39))
		ReturnCode = objPauseService.PauseService()
		if ReturnCode = 0 then
			ServiceUpdate()
		end if
		WScript.Echo " : " & ReturnCode
	end if
end function

'      
function ServiceContinue(Sender)
	dim cur_service_name, ReturnCode, objResumeService
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		
		set objResumeService = objWMIService.Get("Win32_Service.Name=" & Chr(39) & cur_service_name & Chr(39))
		ReturnCode = objResumeService.ResumeService()
		if ReturnCode = 0 then
			ServiceUpdate()
		end if
		WScript.Echo " : " & ReturnCode
	end if
end function

'     
function ServiceAuto(Sender)
	dim cur_service_name, cur_service_state
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		cur_service_state = data_array(list_view_obj.ItemIndex).State
		WshShell.Run "cmd.exe /c sc config " & cur_service_name & " start= Auto" & " > " + temp_file,1,true
		open_temp_file()
		ServiceUpdate()
	end if
end function

'     
function ServiceManual(Sender)
	dim cur_service_name, cur_service_state
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		cur_service_state = data_array(list_view_obj.ItemIndex).State
		WshShell.Run "cmd.exe /c sc config " + cur_service_name + " start= Demand" + " > " + temp_file,1,true
		open_temp_file()
		ServiceUpdate()
	end if
end function

'  
function ServiceDisable(Sender)
	dim cur_service_name, cur_service_state
	'   
	if list_view_obj.ItemIndex<0 then
		WScript.Echo "   "
	'  
	elseif ServiceDialog() = 1 then
		cur_service_name = data_array(list_view_obj.ItemIndex).Name
		cur_service_state = data_array(list_view_obj.ItemIndex).State
		WshShell.Run "cmd.exe /c sc config " + cur_service_name + " start= Disabled" + " > " + temp_file,1,true
		open_temp_file()
		ServiceUpdate()
	end if
end function

'   
function ServiceDialog()
dim cur_service_name, Msg, Title, result
	cur_service_name = data_array(list_view_obj.ItemIndex).Name
	
	Msg = " ,      " & cur_service_name & " ?"
	Title = ",       "
		result = MsgBox(Msg, vbOKCancel + vbInformation, Msg)
	'   ,    
		if result = vbOK then
			ServiceDialog = 1
		else
			ServiceDialog = 0
		end if
end function

'   
function open_temp_file()
dim get_file_data, data_file
	set get_file_data=FSO.OpenTextFile(temp_file, 1, false)
	data_file = get_file_data.ReadAll()
	get_file_data.Close()
	WshShell.Run "wordpad.exe " & temp_file
end function

Sub on_data(sender, item)
	dim data, ix
	'
	sender.BeginUpdate()
		
	'    
	for ix = 0 to UBound(def_columns)
		def_columns(ix).set_data item, data_array(item.Index)'data
	next
		
	'
	sender.EndUpdate()
end sub
                               
'    
CreateListView()

f.Show()
WSO.Run()